

    File: source\asm\ccs.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    1

    xxxx-ii-yyyy-cc-f--oooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


       1       1  0 +  0000                                   ;-------------------------------------------------------
       2       2  0 +                                         ;       Iron Spring PL/I Runtime Library Version 0.5
       3       3  0 +                                         ;          Distributed under the Gnu LGPL License
       4       4  0 +                                         ;
       5       5  0 +                                         ;       _pli_CCS - PL/I runtime support routines
       6       6  0 +                                         ;       Version 0.1 Alpha -- May, 2002
       7       7  0 +                                         ;       Copyright Peter Flass
       8       8  0 +                                         ;
       9       9  0 +                                         ;       This module is a generalized character-string
      10      10  0 +                                         ;       compare.
      11      11  0 +                                         ;
      12      12  0 +                                         ; To Do:        This could probably be rewritten in PL/I to
      13      13  0 +                                         ;               call a possible COMPARE BIF, but this version
      14      14  0 +                                         ;               should do for now.
      15      15  0 +                                         ;
      16      16  0 +                                         ;       Arguments:
      17      17  0 +                                         ;         EBP+8   (param 1) address of first argument string
      18      18  0 +                                         ;         EBP+12  (param 2) length  "   "     "         "
      19      19  0 +                                         ;         EBP+16  (param 3) address of second argument string
      20      20  0 +                                         ;         EBP+20  (param 4) length  "   "     "         "
      21      21  0 +                                         ;
      22      22  0 +                                         ;       Modifications:
      23      23  0 +                                         ;
      24      24  0 +                                         ;-------------------------------------------------------
      25      25  0 +            @Cpu=00000D8F                            .386P
      26      26  0 +                                                     .model flat,syscall
      27      27  0 +                                                     public _pli_CCS
      28      28  0 +
      29      29  0 +                                                     include framedef.inc
      30  1    1  0 +                                             ;
      31  1    2  0 +                                             ;----------------------------------------------------+
      32  1    3  0 +                                             ;       PL/I Stack Frame Definition                  |
      33  1    4  0 +                                             ;----------------------------------------------------+
      34  1    5  0 +            =00000000                        frm_ebp equ      0      ; Previous caller's EBP 20040802
      35  1    6  0 +            =FFFFFFFC                        frm_edi equ     -4      ; Caller's EDI
      36  1    7  0 +            =FFFFFFF8                        frm_esi equ     -8      ; Caller's ESI
      37  1    8  0 +            =FFFFFFF4                        frm_ebx equ     -12     ; Caller's EBX
      38  1    9  0 +            =FFFFFFF0                        frm_epa equ     -16     ; Called Entry point address
      39  1   10  0 +            =FFFFFFEC                        frm_stt equ     -20     ; A(Statement number table)
      40  1   11  0 +            =FFFFFFE8                        frm_chc equ     -24     ; ONCB chain
      41  1   12  0 +            =FFFFFFE6                        frm_msk equ     -26     ; Condition mask
      42  1   13  0 +            =FFFFFFE4                        frm_epi equ     -28     ; Entry point id
      43  1   14  0 +            =FFFFFFE0                        frm_bos equ     -32     ; Current permanent BOS
      44  1   15  0 +            =00000020                        frm_len equ      32     ; Size of frame
      45  1   16  0 +
      46      30  0 +                                             ;------------------------------------------------+
      47      31  0 +                                             ;  Unique Stack Data for _pli_CCS                |
      48      32  0 +                                             ;------------------------------------------------+
      49      33  0 +            =FFFFFFE0                        frm_loc equ     frm_bos         ; Start of locals for _pli_CCS
      50      34  0 +            =FFFFFFDC                        saveecx equ     frm_loc-4       ; -4 Saved length
      51      35  0 +            =FFFFFFDC                        loc_end equ     frm_loc-4       ; End of locals
      52      36  0 +            =00000004                        loc_len equ     frm_loc-loc_end ;                          20050803
      53      37  0 +            =00000024                        frm_siz equ     frm_len+loc_len ; Total stack frame length 20050803
      54      38  0 +
      55      39  0 +                                                     .data


    File: source\asm\ccs.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    2

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


      56      40  0 +            =00000000                        _pli_data equ $
      57      41  0 +
      58      42  0 +                                                     .code                   ; PL/I Compatible entry code
      59      43  0 +            =00000000                        _pli_code equ $
      60      44  0 +  00000000  20 02 05 14 14 30 00                     db 20h,02h,05h,14h,14h,30h,00h,00h
                                 00
      61      45  0 +  00000008  5F 70 6C 69 5F 43 43                     db '_pli_CCS'
                                 53
      62      46  0 +  00000010  08                                       db 8
      63      47  0 +  00000011                                   _pli_CCS:
      64      48  0 +  00000011  FF 17                                    call dword ptr 0[edi]
      65      49  0 +  00000013  00000024                                 dd frm_siz                      ; DSA size          20031007
      66      50  0 +  00000017  66:C7 45 [E4] 81E1                       mov word ptr -28[ebp],81E1h     ; Condition prefix flags
      67      51  0 +  0000001D  8B 4D [0C]                               mov ecx,dword ptr 12[ebp]       ; Load first arg length
      68      52  0 +  00000020  3B 4D [14]                               cmp ecx,dword ptr 20[ebp]       ; Compare to second arg length
      69      53  0 +  00000023  7E 07 90 90 90 90                        jle lenset                      ; First arg length less
      70      54  0 +  00000029  8B 4D [14]                               mov ecx,dword ptr 20[ebp]       ; Second arg length less
      71      55  0 +  0000002C                                   lenset:
      72      56  0 +  0000002C  89 4D [DC]                               mov saveecx[ebp],ecx            ; Save length compared
      73      57  0 +  0000002F  85 C9                                    test ecx,ecx                    ; Zero-length string?
      74      58  0 +  00000031  74 18 90 90 90 90                        jz  zerolen                     ; yes, skip compare
      75      59  0 +  00000037  8B 75 [08]                               mov esi,dword ptr 8[ebp]        ; Load first arg address
      76      60  0 +  0000003A  8B 7D [10]                               mov edi,dword ptr 16[ebp]       ; Load second arg address
      77      61  0 +  0000003D  F3:A6                                    repe cmpsb                      ; compare strings       20050803
      78      62  0 +  0000003F  72 69 90 90 90 90                        jb  isless                      ; First string less     20050803
      79      63  0 +  00000045  77 6D 90 90 90 90                        ja  ismore                      ; First string greater  20050803
      80      64  0 +  0000004B                                   zerolen:
      81      65  0 +                                             ;-------------------------------------------
      82      66  0 +                                             ; control gets here if the strings are
      83      67  0 +                                             ; equal for the length of the shorter
      84      68  0 +                                             ; string (or if the shorter is zero length)
      85      69  0 +                                             ;-------------------------------------------
      86      70  0 +  0000004B  BB 00000000                              mov ebx,0                       ; Clear swapped flag            20050803
      87      71  0 +  00000050  8B 7D [08]                               mov edi,dword ptr 8[ebp]        ; Assume first arg is longer
      88      72  0 +  00000053  8B 4D [0C]                               mov ecx,dword ptr 12[ebp]       ; Load first arg length
      89      73  0 +  00000056  2B 4D [14]                               sub ecx,dword ptr 20[ebp]       ; Subtract second arg length
      90      74  0 +  00000059  7F 0E 90 90 90 90                        jg  long1                       ; First arg longer
      91      75  0 +  0000005F  BB 00000001                              mov ebx,1                       ; Set swapped flag              20050803
      92      76  0 +  00000064  8B 7D [10]                               mov edi,dword ptr 16[ebp]       ; Otherwise second arg longer
      93      77  0 +  00000067  F7 D9                                    neg ecx
      94      78  0 +  00000069                                   long1:
      95      79  0 +  00000069  85 C9                                    test ecx,ecx                    ; Test for string lengths equal
      96      80  0 +  0000006B  74 17 90 90 90 90                        je   isequal                    ; yes, equal compare
      97      81  0 +  00000071  03 7D [DC]                               add edi,saveecx[ebp]            ; Skip characters compared      20050803
      98      82  0 +  00000074  B0 20                                    mov byte ptr al,' '
      99      83  0 +  00000076  F3:AE                                    repe scasb                      ; Longer string must be all blanks 50803
     100      84  0 +  00000078  77 14 90 90 90 90                        ja  isless1                     ; Longer string < blanks        20050803
     101      85  0 +  0000007E  72 1C 90 90 90 90                        jb  ismore1                     ; Longer string > blanks        20050803
     102      86  0 +  00000084                                   isequal:
     103      87  0 +  00000084  B8 00000000                              mov eax,0                       ; Arguments equal
     104      88  0 +  00000089  EB 2E 90 90 90                           jmp ret                         ; exit
     105      89  0 +  0000008E                                   isless1:
     106      90  0 +  0000008E  83 FB 00                                 cmp  ebx,0                      ; Which arg did we look at?
     107      91  0 +  00000091  74 17 90 90 90 90                        je   isless                     ; first
     108      92  0 +  00000097  EB 1B 90 90 90                           jmp  ismore                     ; second


    File: source\asm\ccs.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    3

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     109      93  0 +  0000009C                                   ismore1:
     110      94  0 +  0000009C  83 FB 00                                 cmp  ebx,0
     111      95  0 +  0000009F  74 13 90 90 90 90                        je   ismore
     112      96  0 +  000000A5  EB 03 90 90 90                           jmp  isless
     113      97  0 +                                             ;----------------------------------
     114      98  0 +                                             ;       Return to caller
     115      99  0 +                                             ;----------------------------------
     116     100  0 +  000000AA  B8 FFFFFFFF                      isless: mov eax,-1                      ; First arg < Second arg
     117     101  0 +  000000AF  EB 08 90 90 90                           jmp ret
     118     102  0 +  000000B4  B8 00000001                      ismore: mov eax,1                       ; First arg > Second arg
     119     103  0 +  000000B9                                   ret:
     120     104  0 +  000000B9  8B 5D [F4]                               mov ebx,dword ptr -12[ebp]
     121     105  0 +  000000BC  8B 75 [F8]                               mov esi,dword ptr -8[ebp]
     122     106  0 +  000000BF  8B 7D [FC]                               mov edi,dword ptr -4[ebp]
     123     107  0 +  000000C2  C9                                       leave
     124     108  0 +  000000C3  C3                                       ret
     125     109  0 +
     126     110  0 +            =000000C4                        _pli_endc equ $
     127     111  0 +                                                     .data
     128     112  0 +  00000000                                           org _pli_data+00h
     129     113  0 +            =00000000                        _pli_endd equ $
     130     114  0 +                                                     end
