

    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    1

    xxxx-ii-yyyy-cc-f--oooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


       1       1  0 +  0000                                   ;-------------------------------------------------------
       2       2  0 +                                         ;       Iron Spring PL/I Runtime Library Version 0.5
       3       3  0 +                                         ;          Distributed under the Gnu LGPL License
       4       4  0 +                                         ;
       5       5  0 +                                         ;       _pli_Init - PL/I runtime support routines
       6       6  0 +                                         ;       Version 0.1 Alpha -- Sep, 1998
       7       7  0 +                                         ;       Copyright Peter Flass
       8       8  0 +                                         ;       This module contains most of the OS dependencies
       9       9  0 +                                         ;       Compiler-generated code should be OS independent.
      10      10  0 +                                         ;
      11      11  0 +                                         ;       _pli_Init is the second stage of PL/I initialization.
      12      12  0 +                                         ;       It is called by _pli_Start, which is statically linked
      13      13  0 +                                         ;       with the user's .EXE.  It is passed the address of
      14      14  0 +                                         ;       the Global Data Structure in EAX, which it stores in
      15      15  0 +                                         ;       entry 127 in the PGT so that the Global Data can be
      16      16  0 +                                         ;       referenced both from the .EXE and the PL/I DLL if
      17      17  0 +                                         ;       the DLL is used instead of static linkage.
      18      18  0 +                                         ;
      19      19  0 +                                         ;       To Do:
      20      20  0 +                                         ;         . Add addr(TDA_address) to PGT.
      21      21  0 +                                         ;           [TDA_address is stored in thread local storage].
      22      22  0 +                                         ;         . See note on parm analyzer.
      23      23  0 +                                         ;         . Probably should have definition of 'GBL',
      24      24  0 +                                         ;           and definition of TIB.
      25      25  0 +                                         ;
      26      26  0 +                                         ;       Modifications:
      27      27  0 +                                         ;         2007-11-08 - @00003 - fix PLITABS linkage.
      28      28  0 +                                         ;         2007-06-09 - Fix for problem with DosGetInfoBlocks
      29      29  0 +                                         ;         2007-03-20 - New version of 'GCL'.
      30      30  0 +                                         ;         2006-10-17 - Fix return of pliretc()
      31      31  0 +                                         ;         2006-09-27 - Reload addr(PGT) at 'exit' in case
      32      32  0 +                                         ;                       exit is jumped to out of SIG.
      33      33  0 +                                         ;         2006-08-08 - Fix invalid branch in 'probe'
      34      34  0 +                                         ;         2006-02-01 - Fix 'fpmask' for x87 setup
      35      35  0 +                                         ;         2005-05-09 - zero entry point id in DSA
      36      36  0 +                                         ;         2005-01-05 - add _pli_OTH (OTHERWISE) handler
      37      37  0 +                                         ;         2004-12-22 - Add addr(ATTN_ONCB) after ExceptionRegistrationRecord
      38      38  0 +                                         ;         2004-06-09 - Add initialization for major task TID
      39      39  0 +                                         ;         2004-05-26 - DosSetSignalExceptionFocus
      40      40  0 +                                         ;         2004-05-24 - Set initial FPU control word
      41      41  0 +                                         ;         2004-05-11 - Fix Error trapping problem
      42      42  0 +                                         ;         2003-12-14 - Rename _pli_Init, set up so that the
      43      43  0 +                                         ;                       library can run as a DLL.
      44      44  0 +                                         ;         2003-07-03 - Add heap storage allocation
      45      45  0 +                                         ;         2002-07-18 - Create _pli_End EXTERNAL label variable
      46      46  0 +                                         ;         2002-06-25 - Save A(PGT) in my stack frame to make _pli_Start
      47      47  0 +                                         ;                       look like a PL/I program for stack trace.
      48      48  0 +                                         ;         2002-06-04 - Error in SFI
      49      49  0 +                                         ;         2002-04-26 - Add beginnings of trap handler
      50      50  0 +                                         ;         2001-03-02 - Add Parm scanner
      51      51  0 +                                         ;
      52      52  0 +                                         ;-------------------------------------------------------
      53      53  0 +            @Cpu=00000D8F                            .386P
      54      54  0 +                                                     .model flat,syscall
      55      55  0 +


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    2

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


      56      56  0 +                                                     .code
      57      57  0 +            =00000000                        _pli_code equ $
      58      58  0 +                                                     public _pli_Init                                        ; 20031214
      59      59  0 +                                                     public _pli_PGT
      60      60  0 +                                                     public _pli_Def_Cond
      61      61  0 +
      62      62  0 +                                                     extern DosAllocMem:near
      63      63  0 +                                                     extern DosExit:near
      64      64  0 +                                                     extern DosFreeMem:near
      65      65  0 +                                                     extern DosGetInfoBlocks:near
      66      66  0 +                                                     extern DosSetExceptionHandler:near
      67      67  0 +                                                     extern DosSetSignalExceptionFocus:near
      68      68  0 +                                                     extern DosSubSetMem:near
      69      69  0 +                                                     extern DosSubUnsetMem:near
      70      70  0 +                                                     extern DosUnsetExceptionHandler:near
      71      71  0 +
      72      72  0 +                                                     extern _pli_Main:near
      73      73  0 +                                                     extern _pli_GCL:near
      74      74  0 +                                                     extern _pli_Trap:near
      75      75  0 +                                                     extern _pli_Tabs:near   ;                               @00003
      76      76  0 +
      77      77  0 +                                                     include tda.inc
      78  1    1  0 +                                             ;
      79  1    2  0 +                                             ;----------------------------------------------------+
      80  1    3  0 +                                             ;       PL/I Task Data Area (TDA) definition         |
      81  1    4  0 +                                             ;----------------------------------------------------+
      82  1    5  0 +                                             ;       (a few equates in areas not completely defined here)
      83  1    6  0 +            =00000030                        GBL_TDA_anchor  equ     30h     ; Addr of TDA in GBL
      84  1    7  0 +            =0000000C                        TIB_pTib2       equ     0Ch     ; -> TIB2 in TIB
      85  1    8  0 +            =00000000                        TIB2_ulTid      equ     00h     ; Thread ID in TIB2
      86  1    9  0 +            =00000004                        TIB2_ulPri      equ     04h     ; Thread priority in TIB2
      87  1   10  0 +                                             ;
      88  1   11  0 +            =00000000                        TDA_next        equ     0       ; Addr(next_TDA)
      89  1   12  0 +            =00000004                        TDA_prev        equ     4       ; Addr(prev_TDA)
      90  1   13  0 +            =00000008                        TDA_nextchild   equ     8       ; Addr(next_child_TDA)
      91  1   14  0 +            =0000000C                        TDA_prevchild   equ     12      ; Addr(prev_child_TDA)
      92  1   15  0 +            =00000010                        TDA_parent      equ     16      ; Addr(parent_TDA)
      93  1   16  0 +            =00000014                        TDA_TID         equ     20      ; Thread ID
      94  1   17  0 +            =00000018                        TDA_priority    equ     24      ; Priority
      95  1   18  0 +            =0000001C                        TDA_alloc_cnt   equ     28      ; Alloc Cnt for CTL stg
      96  1   19  0 +            =00000020                        TDA_event       equ     32      ; Addr(event_variable)
      97  1   20  0 +            =00000024                        TDA_stack       equ     36      ; Addr(stack)
      98  1   21  0 +            =00000028                        TDA_heap        equ     40      ; Addr(heap)
      99  1   22  0 +            =0000002C                        TDA_flags       equ     44      ; Flag byte
     100  1   23  0 +                                             ;               80h = Major Task TDA
     101  1   24  0 +            =0000002D                        TDA_fil1        equ     45      ; (alignment)
     102  1   25  0 +            =00000030                        TDA_ctl         equ     48      ; CTL storage chain
     103  1   26  0 +            =00000034                        TDA_fil2        equ     52      ; (unused)
     104  1   27  0 +
     105      78  0 +                                                     include framedef.inc
     106  1    1  0 +                                             ;
     107  1    2  0 +                                             ;----------------------------------------------------+
     108  1    3  0 +                                             ;       PL/I Stack Frame Definition                  |
     109  1    4  0 +                                             ;----------------------------------------------------+
     110  1    5  0 +            =00000000                        frm_ebp equ      0      ; Previous caller's EBP 20040802


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    3

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     111  1    6  0 +            =FFFFFFFC                        frm_edi equ     -4      ; Caller's EDI
     112  1    7  0 +            =FFFFFFF8                        frm_esi equ     -8      ; Caller's ESI
     113  1    8  0 +            =FFFFFFF4                        frm_ebx equ     -12     ; Caller's EBX
     114  1    9  0 +            =FFFFFFF0                        frm_epa equ     -16     ; Called Entry point address
     115  1   10  0 +            =FFFFFFEC                        frm_stt equ     -20     ; A(Statement number table)
     116  1   11  0 +            =FFFFFFE8                        frm_chc equ     -24     ; ONCB chain
     117  1   12  0 +            =FFFFFFE6                        frm_msk equ     -26     ; Condition mask
     118  1   13  0 +            =FFFFFFE4                        frm_epi equ     -28     ; Entry point id
     119  1   14  0 +            =FFFFFFE0                        frm_bos equ     -32     ; Current permanent BOS
     120  1   15  0 +            =00000020                        frm_len equ      32     ; Size of frame
     121  1   16  0 +
     122      79  0 +                                             ;------------------------------------------------+
     123      80  0 +                                             ;  Unique Stack Data for _pli_Init               |
     124      81  0 +                                             ;------------------------------------------------+
     125      82  0 +            =FFFFFFE0                        frm_loc equ     frm_bos         ; Start of locals for _pli_Init
     126      83  0 +            =FFFFFFDC                        loc_edi equ     frm_loc-4       ; Caller's EDI 20020625
     127      84  0 +            =FFFFFFD8                        ERRHnd  equ     frm_loc-8       ; -> Error handler
     128      85  0 +            =FFFFFFD4                        ERRPerr equ     frm_loc-12      ; -> Previous Exception Rec
     129      86  0 +            =FFFFFFD4                        ERegRec equ     frm_loc-12      ; Exception Registration Record
     130      87  0 +            =FFFFFFD0                        EAttnCB equ     frm_loc-16      ; addr(ATTENTION_ONCB)          20041222
     131      88  0 +            =FFFFFFCC                        tib_addr equ    frm_loc-20      ; Temporary                     20070609
     132      89  0 +            =FFFFFFC8                        pib_addr equ    frm_loc-24      ;                               20070609
     133      90  0 +            =FFFFFFC4                        loc_end equ     frm_loc-28      ; end of local stack            20070609
     134      91  0 +            =0000001C                        loc_len equ     frm_loc-loc_end ; Length of local stack
     135      92  0 +                                             ;
     136      93  0 +                                             ;-----------------------------------------------------
     137      94  0 +                                             ;       _pli_Init:  Initialize PL/I MAIN procedure
     138      95  0 +                                             ;-----------------------------------------------------
     139      96  0 +  00000000  5F 70 6C 69 5F 49 6E                     db   '_pli_Init'; Entry point name
                                 69 74
     140      97  0 +  00000009  09                                       db   9          ; Length of name
     141      98  0 +  0000000A                                   _pli_Init:
     142      99  0 +  0000000A  A3 [00000234]:R                          mov  dword ptr _pli_PGT+(127*4),eax; Save a(_pli_gbl_data)   20031214
     143     100  0 +  0000000F  55                                       push ebp                ; Save caller's EBP
     144     101  0 +  00000010  8B EC                                    mov  ebp,esp            ; Save registers
     145     102  0 +  00000012  83 EC 3C                                 sub  esp,frm_len+loc_len; Reserve stack frame
     146     103  0 +  00000015  89 65 [E0]                               mov  frm_bos[ebp],esp   ; Save BOS address
     147     104  0 +  00000018  89 7D [DC]                               mov  loc_edi[ebp],edi   ; Save caller's registers 20020625
     148     105  0 +  0000001B  89 75 [F8]                               mov  frm_esi[ebp],esi   ;   (edi,esi,ebx)
     149     106  0 +  0000001E  89 5D [F4]                               mov  frm_ebx[ebp],ebx
     150     107  0 +  00000021  C7 45 [F0]                               mov  dword ptr frm_epa[ebp],offset _pli_Init
                                 0000000A:R
     151     108  0 +  00000028  C7 45 [EC] 00000000                      mov  dword ptr frm_stt[ebp],0           ; Statement number table
     152     109  0 +  0000002F  C7 45 [E8] 00000000                      mov  dword ptr frm_chc[ebp],0           ; Condition handler chain
     153     110  0 +  00000036  66:A1 [000002CA]:R                       mov  ax,word ptr _pli_Def_Cond          ; Enabled conditions
     154     111  0 +  0000003C  66:89 45 [E6]                            mov  frm_msk[ebp],ax    ; Condition mask
     155     112  0 +  00000040  BF 00000038:R                            mov  edi,offset _pli_PGT; load a(PGT)
     156     113  0 +  00000045  89 7D [FC]                               mov  frm_edi[ebp],edi   ; Indicate PL/I stack frame 20020625
     157     114  0 +  00000048  8B F5                                    mov  esi,ebp            ; Static backchain
     158     115  0 +  0000004A  DB E3                                    fninit                  ; Initialize FPU (may be redundant)
     159     116  0 +  0000004C  D9 2D [000002C8]:R                       fldcw fpmask            ; Set FPU control word      20040524
     160     117  0 +
     161     118  0 +  00000052  FC                                       cld                     ; Clear direction flag
     162     119  0 +                                             ;
     163     120  0 +                                             ;-----------------------------------------------------


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    4

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     164     121  0 +                                             ;       Initialize Major Task TDA [2004-06-09]
     165     122  0 +                                             ;       NOTE: There is a bug in some versions of Warp
     166     123  0 +                                             ;             that will not allow NULL as an argument
     167     124  0 +                                             ;             to DosGetInfoBlocks.  APAR JR10561 is
     168     125  0 +                                             ;             the fix for this in Warp 4.
     169     126  0 +                                             ;-----------------------------------------------------
     170     127  0 +  00000053  8D 45 [C8]                               lea  eax,pib_addr[ebp]                  ; *PTIB         20070609
     171     128  0 +  00000056  50                                       push eax                                ;               20070609
     172     129  0 +  00000057  8D 45 [CC]                               lea  eax,tib_addr[ebp]                  ; *PTIB         20070609
     173     130  0 +  0000005A  50                                       push eax
     174     131  0 +  0000005B  E8 00000000:E                            call DosGetInfoBlocks
     175     132  0 +  00000060  83 C4 08                                 add  esp,8                              ; Pop arguments
     176     133  0 +  00000063  8B 3D [00000234]:R                       mov  edi,dword ptr _pli_PGT+(127*4)     ; addr(_pli_gbl_data)
     177     134  0 +  00000069  8B 7F [30]                               mov  edi,dword ptr GBL_TDA_anchor[edi]  ; addr(initial TDA)
     178     135  0 +  0000006C  8B 45 [CC]                               mov  eax,dword ptr tib_addr[ebp]        ; addr(TIB)     20070609
     179     136  0 +  0000006F  8B 40 [0C]                               mov  eax,dword ptr TIB_pTib2[eax]       ; addr(TIB2)
     180     137  0 +  00000072  8B 18                                    mov  ebx,dword ptr TIB2_ulTid[eax]      ; Thread ID
     181     138  0 +  00000074  89 5F [14]                               mov  dword ptr TDA_TID[edi],ebx
     182     139  0 +  00000077  8B 58 [04]                               mov  ebx,dword ptr TIB2_ulPri[eax]      ; Thread priority
     183     140  0 +  0000007A  89 5F [18]                               mov  dword ptr TDA_priority[edi],ebx
     184     141  0 +  0000007D  C6 47 [2C] 80                            mov  byte ptr TDA_flags[edi],80h        ; 'Major Task'
     185     142  0 +                                             ;       Other fields: Heap addr, stack addr?
     186     143  0 +                                             ;
     187     144  0 +
     188     145  0 +                                             ;--->   Set edi to point to the PGT throughout the rest of initialization <---
     189     146  0 +  00000081  BF 00000038:R                            mov  edi,offset _pli_PGT; load a(PGT)   ; Load PGT address
     190     147  0 +                                             ;--->   From this point on, *do not* use edi without saving and restoring <---
     191     148  0 +
     192     149  0 +                                             ;
     193     150  0 +                                             ;-----------------------------------------------------
     194     151  0 +                                             ;       Initialize Exit address [2002-07-18]
     195     152  0 +                                             ;-----------------------------------------------------
     196     153  0 +  00000086  A1 [0000021F]:R                          mov  eax,AExit          ; Create label variable
     197     154  0 +  0000008B  A3 [00000000]:R                          mov  dword ptr _End,eax
     198     155  0 +  00000090  89 2D [00000004]:R                       mov  dword ptr _End+4,ebp
     199     156  0 +                                             ;
     200     157  0 +                                             ;-----------------------------------------------------
     201     158  0 +                                             ;       Initialize Trap Handler [2002-04-26]
     202     159  0 +                                             ;-----------------------------------------------------
     203     160  0 +  00000096  8D 45 [D4]                               lea  eax,ERegRec[ebp]   ; A(Exception Registration REC)
     204     161  0 +  00000099  C7 00 00000000                           mov  dword ptr 0[eax],0 ; Initialize Chain
     205     162  0 +  0000009F  C7 40 [04]                               mov  dword ptr 4[eax],offset _pli_Trap  ; Exception handler address     20040511
                                 00000000:E
     206     163  0 +  000000A6  C7 40 [08] 00000000                      mov  dword ptr 8[eax],0         ; Init ATTENTION ONCB chain             20041222
     207     164  0 +  000000AD  50                                       push eax
     208     165  0 +  000000AE  E8 00000000:E                            call DosSetExceptionHandler
     209     166  0 +  000000B3  83 C4 04                                 add  esp,4
     210     167  0 +                                             ;
     211     168  0 +                                             ;-----------------------------------------------------
     212     169  0 +                                             ;       Call Parm Analyzer [Rev Mar 20, 2007]
     213     170  0 +                                             ;       [This will run with _pli_Main's stack and no
     214     171  0 +                                             ;       heap storage.]
     215     172  0 +                                             ;-----------------------------------------------------
     216     173  0 +  000000B6  68 00000238:R                            push dword ptr offset _pli_runtime_parms  ; a(runtime parms)            20070320
     217     174  0 +  000000BB  B0 01                                    mov  al,1


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    5

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     218     175  0 +  000000BD  E8 00000000:E                            call _pli_GCL                           ; analyze command line
     219     176  0 +  000000C2  83 C4 04                                 add  esp,4                              ; pop rtp addr                  20070320
     220     177  0 +  000000C5  A1 [00000248]:R                          mov  eax,rtp_lCmdl                      ; Load parm length              20070320
     221     178  0 +  000000CA  A3 [000002C4]:R                          mov  dword ptr desc+4,eax               ; set descriptor length 20070320
     222     179  0 +  000000CF  83 C0 02                                 add  eax,2                              ; Add length(var_str_pfx)       20070320
     223     180  0 +  000000D2  FF 97 [00000010]                         call near ptr GSS*4[edi]                ; Get stack space               20070320
     224     181  0 +  000000D8  8B F8                                    mov  edi,eax                            ; Load the address              20070320
     225     182  0 +  000000DA  89 7D [E0]                               mov  frm_bos[ebp],edi                   ; Save BOS address              20070320
     226     183  0 +  000000DD  89 3D [000002B8]:R                       mov  dword ptr adata,edi                ; Save parm addr        20070320
     227     184  0 +  000000E3  8B 0D [000002C4]:R                       mov  ecx,dword ptr desc+4               ; Length(parm)          20070320
     228     185  0 +  000000E9  66:89 0F                                 mov  word ptr 0[edi],cx                 ; Save string length            20070320
     229     186  0 +  000000EC  85 C9                                    test ecx,ecx                            ; Length=zero?                  20070320
     230     187  0 +  000000EE  74 0F 90 90 90 90                        je   noparm                             ; Yes                           20070320
     231     188  0 +  000000F4  83 C7 02                                 add  edi,2                              ; -> output string              20070320
     232     189  0 +  000000F7  8B 35 [00000244]:R                       mov  esi,rtp_pCmdl                      ; -> input string               20070320
     233     190  0 +  000000FD  F3:A4                                rep movsb                                   ; Move parm to stack            20070320
     234     191  0 +  000000FF                                   noparm:
     235     192  0 +  000000FF  BF 00000038:R                            mov  edi,offset _pli_PGT; load a(PGT)   ; Restore PGT address           20070320
     236     193  0 +
     237     194  0 +                                             ;
     238     195  0 +                                             ;-----------------------------------------------------
     239     196  0 +                                             ;       Allocate heap storage [Jul 3, 2003]
     240     197  0 +                                             ;       The parm analyzer may have changed
     241     198  0 +                                             ;       the size of the heap.
     242     199  0 +                                             ;-----------------------------------------------------
     243     200  0 +  00000104  6A 03                                    push 03H                                ; Flags
     244     201  0 +                                             ;                                                       PAG_READ  01h
     245     202  0 +                                             ;                                                       PAG_WRITE 02h
     246     203  0 +  00000106  A1 [00000238]:R                          mov  eax,def_heap_size                  ; cb (=heap size)
     247     204  0 +  0000010B  50                                       push eax
     248     205  0 +  0000010C  8D 05 00000000:R                         lea  eax,_Heap                          ; ppb
     249     206  0 +  00000112  50                                       push eax
     250     207  0 +  00000113  B0 03                                    mov  al,3
     251     208  0 +  00000115  E8 00000000:E                            call DosAllocMem                        ; Allocate the heap
     252     209  0 +  0000011A  83 C4 0C                                 add  esp,12                             ; pop parms
     253     210  0 +                                             ; NOTE: Need to check return code
     254     211  0 +                                             ;       What to do if error occurs?
     255     212  0 +
     256     213  0 +  0000011D  A1 [00000238]:R                          mov  eax,def_heap_size                  ; cb (=heap size)
     257     214  0 +  00000122  50                                       push eax
     258     215  0 +  00000123  6A 05                                    push 05h                                ; Flags
     259     216  0 +                                             ;                                                       DOSSUB_INIT       01h
     260     217  0 +                                             ;                                                       DOSSUB_SPARSE_OBJ 04h
     261     218  0 +  00000125  A1 [00000000]:R                          mov  eax,dword ptr _Heap                ; Heap address
     262     219  0 +  0000012A  50                                       push eax
     263     220  0 +  0000012B  B0 03                                    mov  al,3
     264     221  0 +  0000012D  E8 00000000:E                            call DosSubSetMem                       ; Initialize the heap
     265     222  0 +  00000132  83 C4 0C                                 add  esp,12                             ; pop parms
     266     223  0 +                                             ; NOTE: Need to check return code
     267     224  0 +                                             ;       What to do if error occurs?
     268     225  0 +                                             ;
     269     226  0 +                                             ;-----------------------------------------------------
     270     227  0 +                                             ;       Initialize I/O Router [Jul 31, 2003]
     271     228  0 +                                             ;-----------------------------------------------------
     272     229  0 +  00000135  68 00320000                              push 00320000h                          ; (0,50) = Initialize


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    6

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     273     230  0 +  0000013A  54                                       push esp                                ; A(code)
     274     231  0 +  0000013B  B0 01                                    mov  al,1
     275     232  0 +  0000013D  E8 00000000:E                            call _pli_IOR
     276     233  0 +  00000142  83 C4 08                                 add  esp,8                              ; pop parms 20031211
     277     234  0 +
     278     235  0 +
     279     236  0 +                                             ;       [NOTE: At this point we want to allocate and
     280     237  0 +                                             ;              switch to the thread 1 stack]
     281     238  0 +                                             ;
     282     239  0 +
     283     240  0 +                                             ;-----------------------------------------------------
     284     241  0 +                                             ;       Set Signal Exception Focus (May 26, 2004)
     285     242  0 +                                             ;-----------------------------------------------------
     286     243  0 +                                             ;
     287     244  0 +  00000145  83 EC 04                                 sub   esp,4             ; Space for returned value
     288     245  0 +  00000148  54                                       push  esp               ; pulTimes
     289     246  0 +  00000149  6A 01                                    push  1                 ; flag: 1=SIG_SETFOCUS
     290     247  0 +  0000014B  E8 00000000:E                            call  DosSetSignalExceptionFocus
     291     248  0 +  00000150  83 C4 0C                                 add   esp,12
     292     249  0 +
     293     250  0 +                                             ;-----------------------------------------------------
     294     251  0 +                                             ;       MAIN procedure should not return a value,
     295     252  0 +                                             ;       but allow for one just in case
     296     253  0 +                                             ;-----------------------------------------------------
     297     254  0 +  00000153  83 EC 0C                                 sub   esp,12            ; Reserve space for returned value
     298     255  0 +  00000156  54                                       push  esp               ; push A(returned_value)
     299     256  0 +  00000157  68 000002B8:R                            push  dword ptr offset _pli_Main_Parm_locdesc
     300     257  0 +  0000015C  B0 01                                    mov   al,1              ; Number of parameters
     301     258  0 +                                             ;                                 EDI->PGT (set above)
     302     259  0 +                                             ;                                 Should we set ESI (static backchain)?
     303     260  0 +  0000015E  E8 00000000:E                            call  _pli_Main         ; Call PL/I main procedure
     304     261  0 +  00000163  83 C4 14                                 add   esp,20            ; Pop parameters off stack
     305     262  0 +
     306     263  0 +                                             ;*****************************************************
     307     264  0 +                                             ;       MAIN procedure or normal return from ERROR
     308     265  0 +                                             ;       returns here
     309     266  0 +                                             ;*****************************************************
     310     267  0 +
     311     268  0 +  00000166                                   exit:
     312     269  0 +
     313     270  0 +                                             ;-----------------------------------------------------
     314     271  0 +                                             ;       Close any open files [Feb 4, 2004]
     315     272  0 +                                             ;-----------------------------------------------------
     316     273  0 +  00000166  BF 00000038:R                            mov  edi,offset _pli_PGT                ; reload a(PGT)         20060927
     317     274  0 +  0000016B  68 00330000                              push 00330000h                          ; (0,51) = Terminate
     318     275  0 +  00000170  54                                       push esp                                ; A(Dummy_IORB)
     319     276  0 +  00000171  B0 01                                    mov  al,1
     320     277  0 +  00000173  E8 00000000:E                            call _pli_IOR
     321     278  0 +  00000178  83 C4 08                                 add  esp,8                              ; pop parms
     322     279  0 +
     323     280  0 +                                             ;
     324     281  0 +                                             ;------------------------------------------+
     325     282  0 +                                             ;       Free heap storage [Jul 16, 2003]   |
     326     283  0 +                                             ;------------------------------------------+
     327     284  0 +  0000017B  A1 [00000000]:R                          mov  eax,dword ptr _Heap        ; Terminate the heap


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    7

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     328     285  0 +  00000180  50                                       push eax
     329     286  0 +  00000181  B0 01                                    mov  al,1
     330     287  0 +  00000183  E8 00000000:E                            call DosSubUnsetMem
     331     288  0 +  00000188  83 C4 04                                 add  esp,4
     332     289  0 +
     333     290  0 +  0000018B  A1 [00000000]:R                          mov  eax,dword ptr _Heap        ; Free heap storage
     334     291  0 +  00000190  50                                       push eax
     335     292  0 +  00000191  B0 01                                    mov  al,1
     336     293  0 +  00000193  E8 00000000:E                            call DosFreeMem
     337     294  0 +  00000198  83 C4 04                                 add  esp,4
     338     295  0 +
     339     296  0 +  0000019B  8D 45 [D4]                               lea  eax,ERegRec[ebp]           ; Terminate Exception Handler
     340     297  0 +  0000019E  50                                       push eax
     341     298  0 +  0000019F  E8 00000000:E                            call DosUnsetExceptionHandler
     342     299  0 +  000001A4  83 C4 04                                 add  esp,4
     343     300  0 +  000001A7  A1 [00000234]:R                          mov  eax,dword ptr _pli_PGT+GBL*4 ; addr(globals)               20070524
     344     301  0 +  000001AC  8B 40 [04]                               mov  eax,4[eax]                 ; Set task return code          20061017
     345     302  0 +  000001AF  50                                       push eax
     346     303  0 +  000001B0  6A 01                                    push 1                          ; Terminate all threads
     347     304  0 +  000001B2  E8 00000000:E                            call DosExit
     348     305  0 +                                                     page


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    8

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     349     306  0 +
     350     307  0 +                                             ;
     351     308  0 +                                             ;-----------------------------------------------------
     352     309  0 +                                             ;       _pli_sfi:  stack frame init at block entry
     353     310  0 +                                             ;       saves:     ebp,ebx,esi,edi
     354     311  0 +                                             ;       destroys:  ecx,edx
     355     312  0 +                                             ;       untouched: eax
     356     313  0 +                                             ;       does stack probes if size(local_stg)>4k
     357     314  0 +                                             ;-----------------------------------------------------
     358     315  0 +  000001B7  5F 70 6C 69 5F 53 46                     db   '_pli_SFI' ; Entry point name
                                 49
     359     316  0 +  000001BF  08                                       db   8          ; Length of name
     360     317  0 +  000001C0                                   _pli_sfi:
     361     318  0 +  000001C0  59                                       pop  ecx        ; restore return address
     362     319  0 +  000001C1  55                                       push ebp        ; [EBP+00]
     363     320  0 +  000001C2  8B EC                                    mov  ebp,esp    ; save stack ptr
     364     321  0 +  000001C4  8B 11                                    mov  edx,0[ecx] ; load size of locals
     365     322  0 +  000001C6  2B E2                                    sub  esp,edx    ; adjust ESP
     366     323  0 +  000001C8  C1 EA 0C                                 shr  edx,12     ; compute number of pages
     367     324  0 +  000001CB  83 FA 00                                 cmp  edx,0      ; < one page
     368     325  0 +  000001CE  74 19 90 90 90 90                        jz   endprobe   ; skip probe
     369     326  0 +  000001D4  8B D5                                    mov  edx,ebp    ; compute current page addr
     370     327  0 +  000001D6  C1 EA 0C                                 shr  edx,12
     371     328  0 +  000001D9  C1 E2 0C                                 shl  edx,12
     372     329  0 +                                             ;---    Stack Probe Loop ---
     373     330  0 +  000001DC                                   probe:
     374     331  0 +  000001DC  81 EA 00001000                           sub  edx,4096           ; back up one page
     375     332  0 +  000001E2  F6 02 00                                 test byte ptr 0[edx],0  ; test access
     376     333  0 +  000001E5  3B D4                                    cmp  edx,esp            ; All done
     377     334  0 +  000001E7  77 F3                                    ja   probe              ; loop for all pages 20060808
     378     335  0 +                                             ;---    End of Stack Probe Loop ---
     379     336  0 +  000001E9                                   endprobe:
     380     337  0 +                                             ;-------------------------------+
     381     338  0 +                                             ;       Format Stack frame      |
     382     339  0 +                                             ;-------------------------------+
     383     340  0 +  000001E9  89 65 [E0]                               mov  frm_bos[ebp],esp   ; Save BOS address
     384     341  0 +  000001EC  89 7D [FC]                               mov  frm_edi[ebp],edi   ; Save caller's registers
     385     342  0 +  000001EF  89 75 [F8]                               mov  frm_esi[ebp],esi   ;   (edi,esi,ebx)
     386     343  0 +  000001F2  89 5D [F4]                               mov  frm_ebx[ebp],ebx
     387     344  0 +  000001F5  8B D1                                    mov  edx,ecx            ; A(local size)
     388     345  0 +  000001F7  83 EA 02                                 sub  edx,2              ; A(entry point) 20020620
     389     346  0 +  000001FA  89 55 [F0]                               mov  frm_epa[ebp],edx
     390     347  0 +  000001FD  C7 45 [EC] 00000000                      mov  dword ptr frm_stt[ebp],0   ; Statement number table
     391     348  0 +  00000204  8B 75 [00]                               mov  esi,0[ebp]         ; Address of caller's stack frame 20020604
     392     349  0 +  00000207  8B 56 [E8]                               mov  edx,frm_chc[esi]   ; Static condition handler chain
     393     350  0 +  0000020A  89 55 [E8]                               mov  frm_chc[ebp],edx
     394     351  0 +  0000020D  C6 45 [E4] 00                            mov  byte ptr frm_epi[ebp],0    ; Entry point id                  20050509
     395     352  0 +  00000211  66:8B 56 [E6]                            mov  dx,frm_msk[esi]    ; Static condition mask
     396     353  0 +  00000215  66:89 55 [E6]                            mov  frm_msk[ebp],dx
     397     354  0 +  00000219  FC                                       cld                     ; Clear direction flag
     398     355  0 +  0000021A  83 C1 04                                 add  ecx,4              ; skip over size
     399     356  0 +  0000021D  FF E1                                    jmp  ecx                ; return to caller
     400     357  0 +
     401     358  0 +                                             ;---------------------------------------+
     402     359  0 +                                             ; Address of exit routine               |


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    9

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     403     360  0 +                                             ;---------------------------------------+
     404     361  0 +  0000021F  00000166:R                       AExit   dd      exit
     405     362  0 +                                                     PAGE


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:   10

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     406     363  0 +
     407     364  0 +                                                     .data
     408     365  0 +            =00000000                        _pli_data equ $
     409     366  0 +  00000000                                           align 4
     410     367  0 +                                             ;
     411     368  0 +                                             ;------------------------------------------------+
     412     369  0 +                                             ;       PL/I Program Global Table (PGT)          |
     413     370  0 +                                             ;       For upward-compatibility, do not move    |
     414     371  0 +                                             ;       or delete entries, or change the calling |
     415     372  0 +                                             ;       sequences.  New entries may be added.    |
     416     373  0 +                                             ;------------------------------------------------+
     417     374  0 +                                             ;             Memory comments, version, etc.
     418     375  0 +                                             ;             ....|....1....|....2....|....3
     419     376  0 +  00000000  50 4C 2F 49 20 30 2E                     db   'PL/I 0.1 Alpha  '         ; -56 -  -41
                                 31 20 41 6C 70 68 61
                                 20 20
     420     377  0 +  00000010  43 6F 70 79 72 69 67                     db   'Copyright Peter Flass,  ' ; -40 -  -17
                                 68 74 20 50 65 74 65
                                 72 20 46 6C 61 73 73
                                 2C 20 20
     421     378  0 +  00000028  53 65 70 2C 20 31 39                     db   'Sep, 1998       '         ; -16 -   -1
                                 39 38 20 20 20 20 20
                                 20 20
     422     379  0 +
     423     380  0 +                                             ;       Intrinsic Function IDs
     424     381  0 +            =00000000                        SFI     EQU  0          ; Stack Frame Init
     425     382  0 +            =00000004                        GSS     EQU  4          ; Get Stack storage                             20070320
     426     383  0 +            =00000006                        GHS     EQU  6          ; Get Heap storage
     427     384  0 +            =00000007                        FHS     EQU  7          ; Free Heap storage
     428     385  0 +            =00000010                        SIG     EQU  16         ; SIGNAL condition
     429     386  0 +            =00000011                        ONR     EQU  17         ; ON/REVERT condition
     430     387  0 +            =00000014                        OTH     EQU  20         ; Default OTHERWISE handler                     20050105
     431     388  0 +            =0000001E                        IOR     EQU  30         ; I/O Router
     432     389  0 +            =0000002E                        CCS     EQU  46         ; Compare character string
     433     390  0 +            =0000007F                        GBL     EQU  127        ; addr(_pli_gbl_data)                           20070524
     434     391  0 +            =00000080                        NIF     EQU  128        ; Number of entries in table
     435     392  0 +
     436     393  0 +                                                     extern _pli_IIC:near            ; Invalid call (compiler error)
     437     394  0 +                                                     extern _pli_GSS:near            ; (04) Get Stack Storage
     438     395  0 +                                                     extern _pli_GHS:near            ; (06) Get Heap Storage
     439     396  0 +                                                     extern _pli_FHS:near            ; (07) Free Heap Storage
     440     397  0 +                                                     extern _pli_Sig:near            ; (16) SIGNAL Condition
     441     398  0 +                                                     extern _pli_OnRev:near          ; (17) ON/REVERT Condition
     442     399  0 +                                                     extern _pli_OTH:near            ; (20) Default OTHERWISE handler20050105
     443     400  0 +                                                     extern _pli_IOR:near            ; (30) I/O Router
     444     401  0 +                                                     extern _pli_CCS:near            ; (46) Character String compare
     445     402  0 +
     446     403  0 +            =00000038                        _pli_PGT equ  $         ; PL/I intrinsic routine addresses
     447     404  0 +  00000038  000001C0:R                               dd   offset _pli_sfi            ; 0:    Stack Frame Init
     448     405  0 +  0000003C  00000000:E                               dd   offset _pli_IIC            ; 1:
     449     406  0 +  00000040  00000000:E                               dd   offset _pli_IIC            ; 2:
     450     407  0 +  00000044  00000000:E                               dd   offset _pli_IIC            ; 3:
     451     408  0 +  00000048  00000000:E                               dd   offset _pli_GSS            ; 4:    Get Stack Storage
     452     409  0 +  0000004C  00000000:E                               dd   offset _pli_IIC            ; 5:
     453     410  0 +  00000050  00000000:E                               dd   offset _pli_GHS            ; 6:    Get Heap Storage


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:   11

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     454     411  0 +  00000054  00000000:E                               dd   offset _pli_FHS            ; 7:    Free Heap Storage
     455     412  0 +  00000058  00000000:E                               dd   offset _pli_IIC            ; 8:
     456     413  0 +  0000005C  00000000:E                               dd   offset _pli_IIC            ; 9:
     457     414  0 +  00000060  00000000:E                               dd   offset _pli_IIC            ; 10:
     458     415  0 +  00000064  00000000:E                               dd   offset _pli_IIC            ; 11:
     459     416  0 +  00000068  00000000:E                               dd   offset _pli_IIC            ; 12:
     460     417  0 +  0000006C  00000000:E                               dd   offset _pli_IIC            ; 13:
     461     418  0 +  00000070  00000000:E                               dd   offset _pli_IIC            ; 14:
     462     419  0 +  00000074  00000000:E                               dd   offset _pli_IIC            ; 15:
     463     420  0 +  00000078  00000000:E                               dd   offset _pli_Sig            ; 16:   SIGNAL condition
     464     421  0 +  0000007C  00000000:E                               dd   offset _pli_OnRev          ; 17:   ON/REVERT condition
     465     422  0 +  00000080  00000000:E                               dd   offset _pli_IIC            ; 18:
     466     423  0 +  00000084  00000000:E                               dd   offset _pli_IIC            ; 19:
     467     424  0 +  00000088  00000000:E                               dd   offset _pli_OTH            ; 20:   Default OTHERWISE handler 20050105
     468     425  0 +  0000008C  00000000:E                               dd   offset _pli_IIC            ; 21:
     469     426  0 +  00000090  00000000:E                               dd   offset _pli_IIC            ; 22:
     470     427  0 +  00000094  00000000:E                               dd   offset _pli_IIC            ; 23:
     471     428  0 +  00000098  00000000:E                               dd   offset _pli_IIC            ; 24
     472     429  0 +  0000009C  00000000:E                               dd   offset _pli_IIC            ; 25:
     473     430  0 +  000000A0  00000000:E                               dd   offset _pli_IIC            ; 26:
     474     431  0 +  000000A4  00000000:E                               dd   offset _pli_IIC            ; 27:
     475     432  0 +  000000A8  00000000:E                               dd   offset _pli_IIC            ; 28:
     476     433  0 +  000000AC  00000000:E                               dd   offset _pli_IIC            ; 29:
     477     434  0 +  000000B0  00000000:E                               dd   offset _pli_IOR            ; 30:   I/O Router
     478     435  0 +  000000B4  00000000:E                               dd   offset _pli_IIC            ; 31:
     479     436  0 +  000000B8  00000000:E                               dd   offset _pli_IIC            ; 32:
     480     437  0 +  000000BC  00000000:E                               dd   offset _pli_IIC            ; 33:
     481     438  0 +  000000C0  00000000:E                               dd   offset _pli_IIC            ; 34:
     482     439  0 +  000000C4  00000000:E                               dd   offset _pli_IIC            ; 35:
     483     440  0 +  000000C8  00000000:E                               dd   offset _pli_IIC            ; 36:
     484     441  0 +  000000CC  00000000:E                               dd   offset _pli_IIC            ; 37:
     485     442  0 +  000000D0  00000000:E                               dd   offset _pli_IIC            ; 38:
     486     443  0 +  000000D4  00000000:E                               dd   offset _pli_IIC            ; 39:
     487     444  0 +  000000D8  00000000:E                               dd   offset _pli_IIC            ; 40:
     488     445  0 +  000000DC  00000000:E                               dd   offset _pli_IIC            ; 41:
     489     446  0 +  000000E0  00000000:E                               dd   offset _pli_IIC            ; 42:
     490     447  0 +  000000E4  00000000:E                               dd   offset _pli_IIC            ; 43:
     491     448  0 +  000000E8  00000000:E                               dd   offset _pli_IIC            ; 44:
     492     449  0 +  000000EC  00000000:E                               dd   offset _pli_IIC            ; 45:
     493     450  0 +  000000F0  00000000:E                               dd   offset _pli_CCS            ; 46:   Compare character string
     494     451  0 +  000000F4  00000000:E                               dd   offset _pli_IIC            ; 47:
     495     452  0 +  000000F8  00000000:E                               dd   offset _pli_IIC            ; 48:
     496     453  0 +  000000FC  00000000:E                               dd   offset _pli_IIC            ; 49:
     497     454  0 +  00000100  00000000:E                               dd   offset _pli_IIC            ; 50:
     498     455  0 +  00000104  00000000:E                               dd   offset _pli_IIC            ; 51:
     499     456  0 +  00000108  00000000:E                               dd   offset _pli_IIC            ; 52:
     500     457  0 +  0000010C  00000000:E                               dd   offset _pli_IIC            ; 53:
     501     458  0 +  00000110  00000000:E                               dd   offset _pli_IIC            ; 54:
     502     459  0 +  00000114  00000000:E                               dd   offset _pli_IIC            ; 55:
     503     460  0 +  00000118  00000000:E                               dd   offset _pli_IIC            ; 56:
     504     461  0 +  0000011C  00000000:E                               dd   offset _pli_IIC            ; 57:
     505     462  0 +  00000120  00000000:E                               dd   offset _pli_IIC            ; 58:
     506     463  0 +  00000124  00000000:E                               dd   offset _pli_IIC            ; 59:
     507     464  0 +  00000128  00000000:E                               dd   offset _pli_IIC            ; 60:
     508     465  0 +  0000012C  00000000:E                               dd   offset _pli_IIC            ; 61:


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:   12

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     509     466  0 +  00000130  00000000:E                               dd   offset _pli_IIC            ; 62:
     510     467  0 +  00000134  00000000:E                               dd   offset _pli_IIC            ; 63:
     511     468  0 +                                             ;------------------------------------------------ Only 0-63 currently defined
     512     469  0 +  00000138  00000000:E                               dd   offset _pli_IIC            ; 64:
     513     470  0 +  0000013C  00000000:E                               dd   offset _pli_IIC            ; 65:
     514     471  0 +  00000140  00000000:E                               dd   offset _pli_IIC            ; 66:
     515     472  0 +  00000144  00000000:E                               dd   offset _pli_IIC            ; 67:
     516     473  0 +  00000148  00000000:E                               dd   offset _pli_IIC            ; 68:
     517     474  0 +  0000014C  00000000:E                               dd   offset _pli_IIC            ; 69:
     518     475  0 +  00000150  00000000:E                               dd   offset _pli_IIC            ; 70:
     519     476  0 +  00000154  00000000:E                               dd   offset _pli_IIC            ; 71:
     520     477  0 +  00000158  00000000:E                               dd   offset _pli_IIC            ; 72:
     521     478  0 +  0000015C  00000000:E                               dd   offset _pli_IIC            ; 73:
     522     479  0 +  00000160  00000000:E                               dd   offset _pli_IIC            ; 74:
     523     480  0 +  00000164  00000000:E                               dd   offset _pli_IIC            ; 75:
     524     481  0 +  00000168  00000000:E                               dd   offset _pli_IIC            ; 76:
     525     482  0 +  0000016C  00000000:E                               dd   offset _pli_IIC            ; 77:
     526     483  0 +  00000170  00000000:E                               dd   offset _pli_IIC            ; 78:
     527     484  0 +  00000174  00000000:E                               dd   offset _pli_IIC            ; 79:
     528     485  0 +  00000178  00000000:E                               dd   offset _pli_IIC            ; 80:
     529     486  0 +  0000017C  00000000:E                               dd   offset _pli_IIC            ; 81:
     530     487  0 +  00000180  00000000:E                               dd   offset _pli_IIC            ; 82:
     531     488  0 +  00000184  00000000:E                               dd   offset _pli_IIC            ; 83:
     532     489  0 +  00000188  00000000:E                               dd   offset _pli_IIC            ; 84:
     533     490  0 +  0000018C  00000000:E                               dd   offset _pli_IIC            ; 85:
     534     491  0 +  00000190  00000000:E                               dd   offset _pli_IIC            ; 86:
     535     492  0 +  00000194  00000000:E                               dd   offset _pli_IIC            ; 87:
     536     493  0 +  00000198  00000000:E                               dd   offset _pli_IIC            ; 88:
     537     494  0 +  0000019C  00000000:E                               dd   offset _pli_IIC            ; 89:
     538     495  0 +  000001A0  00000000:E                               dd   offset _pli_IIC            ; 90:
     539     496  0 +  000001A4  00000000:E                               dd   offset _pli_IIC            ; 91:
     540     497  0 +  000001A8  00000000:E                               dd   offset _pli_IIC            ; 92:
     541     498  0 +  000001AC  00000000:E                               dd   offset _pli_IIC            ; 93:
     542     499  0 +  000001B0  00000000:E                               dd   offset _pli_IIC            ; 94:
     543     500  0 +  000001B4  00000000:E                               dd   offset _pli_IIC            ; 95:
     544     501  0 +  000001B8  00000000:E                               dd   offset _pli_IIC            ; 96:
     545     502  0 +  000001BC  00000000:E                               dd   offset _pli_IIC            ; 97:
     546     503  0 +  000001C0  00000000:E                               dd   offset _pli_IIC            ; 98:
     547     504  0 +  000001C4  00000000:E                               dd   offset _pli_IIC            ; 99:
     548     505  0 +  000001C8  00000000:E                               dd   offset _pli_IIC            ; 100:
     549     506  0 +  000001CC  00000000:E                               dd   offset _pli_IIC            ; 101:
     550     507  0 +  000001D0  00000000:E                               dd   offset _pli_IIC            ; 102:
     551     508  0 +  000001D4  00000000:E                               dd   offset _pli_IIC            ; 103:
     552     509  0 +  000001D8  00000000:E                               dd   offset _pli_IIC            ; 104:
     553     510  0 +  000001DC  00000000:E                               dd   offset _pli_IIC            ; 105:
     554     511  0 +  000001E0  00000000:E                               dd   offset _pli_IIC            ; 106:
     555     512  0 +  000001E4  00000000:E                               dd   offset _pli_IIC            ; 107:
     556     513  0 +  000001E8  00000000:E                               dd   offset _pli_IIC            ; 108:
     557     514  0 +  000001EC  00000000:E                               dd   offset _pli_IIC            ; 109:
     558     515  0 +  000001F0  00000000:E                               dd   offset _pli_IIC            ; 110:
     559     516  0 +  000001F4  00000000:E                               dd   offset _pli_IIC            ; 111:
     560     517  0 +  000001F8  00000000:E                               dd   offset _pli_IIC            ; 112:
     561     518  0 +  000001FC  00000000:E                               dd   offset _pli_IIC            ; 113:
     562     519  0 +  00000200  00000000:E                               dd   offset _pli_IIC            ; 114:
     563     520  0 +  00000204  00000000:E                               dd   offset _pli_IIC            ; 115:


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:   13

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     564     521  0 +  00000208  00000000:E                               dd   offset _pli_IIC            ; 116:
     565     522  0 +  0000020C  00000000:E                               dd   offset _pli_IIC            ; 117:
     566     523  0 +  00000210  00000000:E                               dd   offset _pli_IIC            ; 118:
     567     524  0 +  00000214  00000000:E                               dd   offset _pli_IIC            ; 119:
     568     525  0 +  00000218  00000000:E                               dd   offset _pli_IIC            ; 120:
     569     526  0 +  0000021C  00000000:E                               dd   offset _pli_IIC            ; 121:
     570     527  0 +  00000220  00000000:E                               dd   offset _pli_IIC            ; 122:
     571     528  0 +  00000224  00000000:E                               dd   offset _pli_IIC            ; 123:
     572     529  0 +  00000228  00000000:E                               dd   offset _pli_IIC            ; 124:
     573     530  0 +  0000022C  00000000:E                               dd   offset _pli_IIC            ; 125:
     574     531  0 +  00000230  00000000:E                               dd   offset _pli_IIC            ; 126:
     575     532  0 +  00000234  00000000                                 dd   0                          ; 127:  _pli_gbl_data
     576     533  0 +            =00000238                        _pli_PGT_end equ $
     577     534  0 +
     578     535  0 +                                                     PAGE


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:   14

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     579     536  0 +                                             ;
     580     537  0 +                                             ;------------------------------------------------+
     581     538  0 +                                             ;       Parameters for runtime library, etc.     |
     582     539  0 +                                             ;------------------------------------------------+
     583     540  0 +  00000238                                           align   4
     584     541  0 +  00000238                                   _pli_runtime_parms:
     585     542  0 +                                             ;def_heap_size  dd      65536                   ; Default Heap size - 64K
     586     543  0 +  00000238  00100000                         def_heap_size   dd      1048576                 ; Default Heap size - 1MB
     587     544  0 +  0000023C  00800000                         def_t1_stk_size dd      1048576*8               ; Stack size for thread 1 - 1MB
     588     545  0 +  00000240  00800000                         def_tn_stk_size dd      1048576*8               ; Stack size for thread n - 1MB
     589     546  0 +  00000244  00000000                         rtp_pCmdl       dd      0                       ; addr(parm)
     590     547  0 +  00000248  00000000                         rtp_lCmdl       dd      0                       ; length(parm)
     591     548  0 +  0000024C  006C * ( 00 )                                    db      108 DUP(0)              ; Reserved for add'l parms
     592     549  0 +
     593     550  0 +                                             ;------------------------------------------------+
     594     551  0 +                                             ;       Parameter for MAIN procedure             |
     595     552  0 +                                             ;       (NOTE: Can move to DSA)                  |
     596     553  0 +                                             ;------------------------------------------------+
     597     554  0 +  000002B8                                           align   4
     598     555  0 +  000002B8                                   _pli_Main_Parm_locdesc:                         ; Locator/Descriptor for Parm
     599     556  0 +  000002B8  000002B8:R                       adata   dd      $                               ;   Parm address
     600     557  0 +  000002BC  000002C0:R                       adesc   dd      offset desc                     ;   Descriptor address
     601     558  0 +  000002C0  11 00 00 00                      desc    db      11h,0,0,0                       ;   Varying String Descriptor
     602     559  0 +  000002C4  00000000                                 dd      0                               ;   . Max string length
     603     560  0 +
     604     561  0 +                                             ;------------------------------------------------+
     605     562  0 +                                             ;  Default enabled conditions                    |
     606     563  0 +                                             ;------------------------------------------------+
     607     564  0 +  000002C8                                           align   2
     608     565  0 +  000002C8  20 0F                            fpmask  db      20h,0Fh                         ; FPU Control word               20060214
     609     566  0 +                                             ;       LOB (exception masks):
     610     567  0 +                                             ;       ..1. .... PE Precision mask   '20'bx
     611     568  0 +                                             ;       ...1 .... UE Underflow mask   '10'bx
     612     569  0 +                                             ;       .... 1... OE Overflow mask    '08'bx
     613     570  0 +                                             ;       .... .1.. ZE Zerodivide mask  '04'bx
     614     571  0 +                                             ;       .... ..1. DE Denormal Op mask '02'bx
     615     572  0 +                                             ;       .... ...1 IE Invalid Op mask  '01'bx
     616     573  0 +                                             ;       HOB (control flags):
     617     574  0 +                                             ;       ...1 .... Infinity Control '01'bx
     618     575  0 +                                             ;       .... xx.. Rounding Control
     619     576  0 +                                             ;               '11'bx - Round toward zero (chop mode)
     620     577  0 +                                             ;       .... ..xx Precision Control
     621     578  0 +                                             ;               '11'bx - Double Extended Precision
     622     579  0 +                                             ;                                                 Double Extended Precision      20050624
     623     580  0 +                                             ;                                                 Round toward zero              20050624
     624     581  0 +                                             ;                                                 #P masked                      20050624
     625     582  0 +  000002CA                                   _pli_Def_Cond:
     626     583  0 +  000002CA  E1 80                                            db      0E1h,80h                ; Initial condition mask
     627     584  0 +                                             ;                       1... .... .... ....   Conversion
     628     585  0 +                                             ;                       .1.. .... .... ....   Fixedoverflow
     629     586  0 +                                             ;                       ..1. .... .... ....   Overflow
     630     587  0 +                                             ;                       ...0 .... .... .... NoSize
     631     588  0 +                                             ;                       .... 0... .... .... NoStringrange
     632     589  0 +                                             ;                       .... .0.. .... .... NoStringsize
     633     590  0 +                                             ;                       .... ..0. .... .... NoSubscriptrange


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:   15

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     634     591  0 +                                             ;                       .... ...1 .... ....   Underflow
     635     592  0 +                                             ;                       .... .... 1... ....   Zerodivide
     636     593  0 +                                             ;                       .... .... .... ...1 PL/I Library Function
     637     594  0 +                                             ;                       (remaining bits undefined, should be zero)
     638     595  0 +                                             ;                       (see PL/I compiler procedure 'KEYWORD')
     639     596  0 +
     640     597  0 +                                             ;------------------------------------------------+
     641     598  0 +                                             ;  External data shared between compiled code    +
     642     599  0 +                                             ;  and the PL/I library.  NOTE: This will not    +
     643     600  0 +                                             ;  work when the library is a DLL.  Find another +
     644     601  0 +                                             ;  scheme: Have the PGT contain or point to      +
     645     602  0 +                                             ;  a structure containing this data.             +
     646     603  0 +                                             ;------------------------------------------------+
     647     604  0 +                                             DGROUP  group  DATA32
     648     605  0 +
     649     606  0 +                                             _pli_End segment dword common '_pli_End'  ; Label variable for exit 20020718
     650     607  0 +                                             ; Should be something like "_pli_Finish".
     651     608  0 +            =00000000                        _End    equ     $                       ;                         20020718
     652     609  0 +  00000000  00000000                                 dd      0                       ;                         20020718
     653     610  0 +  00000004  00000000                                 dd      0                       ;                         20020718
     654     611  0 +  00000008                                   _pli_End ends                           ;                         20020718
     655     612  0 +
     656     613  0 +                                             _pli_Heap segment dword common '_pli_Heap'; Address of heap storage 20030703
     657     614  0 +            =00000000                        _Heap   equ     $                       ;                         20030703
     658     615  0 +  00000000  00000000                                 dd      0                       ;                         20030703
     659     616  0 +  00000004                                   _pli_Heap       ends                    ;                         20030703
     660     617  0 +
     661     618  0 +                                                     end
